/*
 * Copyright (c) Xerox Corporation 1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes, provided that Xerox is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Xerox grants no other licenses expressed or
 * implied. The Xerox trade name should not be used in any advertising
 * without its written permission. 
 *
 * XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
 * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
 * express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * software. 
 */

class AdaptiveRcvr : public Agent {
  public :
    AdaptiveRcvr();
    void recv(Packet* pkt, Handler*);
    int command(int argc, const char*const* argv);
  protected :
    int npkts_;  //total pkts
    double ndelay_; //total cumulative delay
    double lastdelay_;
    double nvar_; //cumulative variance
    u_int32_t lasttimestamp_;
    int off_rtp_;

    virtual int adapt(Packet *pkt,u_int32_t time)=0;
    void print_stats(int fid,int seqno,int send_time,int rcv_time,int play_time);
    void compute_stats(double delay,u_int32_t curr_timestamp,u_int32_t rcv_time);
};

/*Service Priority RELATED STUFF*/
//This is only so that I can print out thte recv times of the packet and queueing 
//delay Actual adaptive receivers should not be aware of this
#define SAMPLERATE 8000
