/*
 * Copyright (c) Xerox Corporation 1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes, provided that Xerox is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Xerox grants no other licenses expressed or
 * implied. The Xerox trade name should not be used in any advertising
 * without its written permission. 
 *
 * XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
 * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
 * express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * software. 
 */

#include "agent.h"
#include "Tcl.h"
#include "packet.h"
#include "rtp.h"
#include "adaptive-receiver.h"
#include <sys/time.h>


class NullRcvr : public AdaptiveRcvr {
  public :
  NullRcvr();
  protected :
  int adapt(Packet *pkt, u_int32_t time);
};

static class NullRcvrClass : public TclClass {
public:
	NullRcvrClass() : TclClass("Agent/NullRcvr") {}
	TclObject* create(int, const char*const*) {
		return (new NullRcvr());

	}
} class_null_rcvr;


NullRcvr::NullRcvr() 
{
}

int NullRcvr::adapt(Packet *pkt, u_int32_t local_clock)
{
  return 0;
}
