/*
 * Copyright (c) Xerox Corporation 1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes, provided that Xerox is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Xerox grants no other licenses expressed or
 * implied. The Xerox trade name should not be used in any advertising
 * without its written permission. 
 *
 * XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
 * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
 * express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * software. 
 */

#include "agent.h"
#include "Tcl.h"
#include "packet.h"
#include "rtp.h"
#include "adaptive-receiver.h"
#include <sys/time.h>

#define PLAYBACK 4000

class RigidRcvr2 : public AdaptiveRcvr {
  public :
  RigidRcvr2();
  protected :
  int adapt(Packet *pkt, u_int32_t time);
};


static class RigidRcvr2Class : public TclClass {
public:
	RigidRcvr2Class() : TclClass("Agent/RigidRcvr2") {}
	TclObject* create(int, const char*const*) {
		return (new RigidRcvr2());

	}
} class_rigid_rcvr2;

RigidRcvr2::RigidRcvr2()
{
}


int RigidRcvr2::adapt(Packet *pkt, u_int32_t local_clock)
{
  int delay;
  hdr_cmn* ch = (hdr_cmn*)pkt->access(off_cmn_);
  register u_int32_t tstamp = (int)ch->timestamp();
  
  if (local_clock-tstamp > PLAYBACK) {
    lastdelay_=-1000; //so that u signal u lost a packet
     // don't know what delay to return here
  }
  
return PLAYBACK-(local_clock-tstamp);
}
