#!/usr/bin/tclsh

set i 0
while { $i < $argc } {
	set L [split [lindex $argv $i] =]
	if { [llength $L] == 2 } {
		set var [lindex $L 0]
		set val [lindex $L 1]
		set $var $val
	}
	incr i
}


set f [open |gnuplot w]
puts $f "cd \"summary\""
puts $f "set data style linespoints"
puts $f "set xrange \[0:1\]"
puts $f "set yrange \[0:1000\]"
puts $f "set xlabel \"LINK UTILIZATION\" "
puts $f "set ylabel \"DELAY(ms)\" "
puts $f "set term po la color"
puts $f "set out \"$bw.$time.$rcvr.del.ps\""
if { $rcvr == "RigidRcvr" } {
    puts $f "set title  \"LOW DELAY\" "
} 
if { $rcvr == "RigidRcvr2" } {
    puts $f "set title  \"HIGH DELAY\" "
} 
if { $rcvr == "VatRcvr"} {
    puts $f "set title  \"AGGRESSIVE\" "
} 
if { $rcvr == "ConsRcvr"} {
    puts $f "set title  \"CONSERVATIVE\" "
}

set cmd "plot "

set cmd "$cmd \"$bw.$time.SPQ.$rcvr.1\" title \"LEVEL 1\", \"$bw.$time.SPQ.$rcvr.2\" title \"LEVEL 2\", \"$bw.$time.DropTail.$rcvr.0\" title \"FIFO\" "
#set cmd "$cmd \"$bw.$time.SPQ.$rcvr.1\" , \"$bw.$time.SPQ.$rcvr.2\" "

puts $f $cmd
puts $f "set term po po mono"
puts $f "set out \"$bw.$time.$rcvr.del.port.ps\""
puts $f "replot"


puts $f "set yrange \[0:4\]"
puts $f "set xlabel \"LINK UTILIZATION\" "
puts $f "set ylabel \"DISTORTION(ms/pkt)\" "
puts $f "set term po la color"
puts $f "set out \"$bw.$time.$rcvr.dis.ps\""
set cmd "plot "

set cmd "$cmd \"$bw.$time.SPQ.$rcvr.dis.1\" title \"LEVEL 1\", \"$bw.$time.SPQ.$rcvr.dis.2\" title \"LEVEL 2\", \"$bw.$time.DropTail.$rcvr.dis.0\" title \"FIFO\" "
#set cmd "$cmd \"$bw.$time.SPQ.$rcvr.dis.1\" , \"$bw.$time.SPQ.$rcvr.dis.2\" "
puts $f $cmd

puts $f "set term po po mono"
puts $f "set out \"$bw.$time.$rcvr.dis.port.ps\""
puts $f "replot"

close $f
