#!/usr/bin/tclsh

set i 0
while { $i < $argc } {
	set L [split [lindex $argv $i] =]
	if { [llength $L] == 2 } {
		set var [lindex $L 0]
		set val [lindex $L 1]
		set $var $val
	}
	incr i
}



set f [open |gnuplot w]
puts $f "cd \"summary\" "
puts $f "set data style linespoints"
puts $f "set xrange \[0:1\]"
puts $f "set yrange \[0:1\]"
puts $f "set xlabel \"LINK UTILIZATION\" "
puts $f "set ylabel \"UTILITY\" "
puts $f "set term po la color"
puts $f "set out \"$bw.$time.$rcvr.util.$utiltype.ps\""
if { $utiltype == "deldis" } {
    puts $f "set title \"DELAY/DISTORTION SENSITIVE \" "
}
if { $utiltype == "del" } {
    puts $f "set title \"DELAY SENSITIVE \" "
}
if { $utiltype == "dis" } {
    puts $f "set title \"DISTORTION SENSITIVE \" "
}
if { $utiltype == "isen" } {
    puts $f "set title \"DELAY/DISTORTION INSENSITIVE \" "
}
set cmd "plot "
set cmd "$cmd \"$bw.$time.SPQ.$rcvr.util.$utiltype.1.avg\" title \"LEVEL 1\", \"$bw.$time.SPQ.$rcvr.util.$utiltype.2.avg\" title \"LEVEL 2\" , \"$bw.$time.DropTail.$rcvr.util.$utiltype.0.avg\" title \"FIFO\" "

puts $f $cmd

puts $f "set term po po mono"
puts $f "set out \"$bw.$time.$rcvr.util.$utiltype.port.ps\""
puts $f "replot"

close $f
