/*
 * Copyright (c) Xerox Corporation 1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes, provided that Xerox is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Xerox grants no other licenses expressed or
 * implied. The Xerox trade name should not be used in any advertising
 * without its written permission. 
 *
 * XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
 * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
 * express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * software. 
 */

#include "spq.h"

static class ServicePriorityClass : public TclClass {
 public:
  ServicePriorityClass() : TclClass("Queue/SPQ") {}
  TclObject* create(int, const char*const*) {
    return (new ServicePriority);
  }
} class_spq;

int 
ServicePriority::command(int argc, const char*const* argv) {
	return Queue::command(argc, argv);
}
/*
 * drop-tail
 */
void ServicePriority::enque(Packet* p)
{
        int i;
	
	hdr_ip* iph= (hdr_ip*)p->access(off_ip_);
	q_[iph->flowid()]->enque(p);
	if (q_[iph->flowid()]->length() > qlimit_[iph->flowid()]) {
	  q_[iph->flowid()]->remove(p);
	  fprintf(stderr,"Dropping packets of fid %d\n",iph->flowid());
	  drop(p);
	}
}

Packet* ServicePriority::deque()
{
  int i;
  for (i=0;i<SVCLEVELS;i++)
    if (q_[i]->length() != 0)
      return q_[i]->deque();
  return 0;
}
