/*
 * Copyright (c) Xerox Corporation 1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes, provided that Xerox is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Xerox grants no other licenses expressed or
 * implied. The Xerox trade name should not be used in any advertising
 * without its written permission. 
 *
 * XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
 * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
 * express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * software. 
 */

#ifndef ns_spq_h
#define ns_spq_h

#include <string.h>
#include "queue.h"

#define SVCLEVELS 2
/*
 * A bounded queuehaving packets of 2 priority levels
 */
class ServicePriority : public Queue {
public:
  ServicePriority() { 
    int i ; 
    char buf[BUFSIZ];
    for (i=0;i<SVCLEVELS;i++) {
      q_[i] = new PacketQueue; 
      qlimit_[i] = 0;
      sprintf(buf,"qlimit%d",i);
      bind(buf,&qlimit_[i]);
    }
    bind("off_ip_",&off_ip_);
  }
protected:
  int command(int argc, const char*const* argv); 
  void enque(Packet*);
  Packet* deque();
  PacketQueue *q_[SVCLEVELS]; /* underlying 2 level queue */
  int qlimit_[SVCLEVELS];
  int off_ip_;
};

#endif
