#
# Copyright (c) Xerox Corporation 1997. All rights reserved.
#
# License is granted to copy, to use, and to make and to use derivative
# works for research and evaluation purposes, provided that Xerox is
# acknowledged in all documentation pertaining to any such copy or
# derivative work. Xerox grants no other licenses expressed or
# implied. The Xerox trade name should not be used in any advertising
# without its written permission. 
#
# XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
# MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
# FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
# express or implied warranty of any kind.
#
# These notices must be retained in any copies of any part of this
# software. 
#

set sources1 20
set sources2 20
set qType SPQ
set rcvrType ConsRcvr
set bw 2.0Mb
#propagation delay
set delay 0.01ms
#simulation time
set runtime 600   
set seed 1
set bgsrcType vic

#utility val params
set uval(m-delsens) [expr -1.0/20]
set uval(c-delsens)  20
set uval(m-dissens) [expr -1.0/1.5]
set uval(c-dissens)  0.5
set uval(m-delinses) [expr -1.0/250]
set uval(c-delinses) 250
set uval(m-disinses) [expr -1.0/4]
set uval(c-disinses) 4


Agent/CBR set seqno_ -1 
Agent/VatRcvr set npkts_ 0 
Agent/VatRcvr set ndelay_ 0
Agent/VatRcvr set nvar_ 0

Agent/ConsRcvr set npkts_ 0 
Agent/ConsRcvr set ndelay_ 0
Agent/ConsRcvr set nvar_ 0

Agent/RigidRcvr set npkts_ 0 
Agent/RigidRcvr set ndelay_ 0
Agent/RigidRcvr set nvar_ 0


Agent/RigidRcvr2 set npkts_ 0 
Agent/RigidRcvr2 set ndelay_ 0
Agent/RigidRcvr2 set nvar_ 0

Agent/NullRcvr set npkts_ 0 
Agent/NullRcvr set ndelay_ 0
Agent/NullRcvr set nvar_ 0

Traffic/Expoo set avg_ 0

Queue set limit_ 1000000
Queue/SPQ set qlimit0  1000000
Queue/SPQ set qlimit1  1000000

set i 0
while { $i < $argc } {
	set L [split [lindex $argv $i] =]
	if { [llength $L] == 2 } {
		set var [lindex $L 0]
		set val [lindex $L 1]
		set $var $val
	}
	incr i
}

#puts stderr $out

ns-random $seed
$defaultRNG seed $seed

Class Utility

Agent/VatRcvr instproc init {delc dels varc vars fid} {
    $self next 
    $self instvar util delconst_ delslope_ varconst_ varslope_ fid_

    set util [new Utility]
    set delconst_ $delc 
    set delslope_ $dels
    set varconst_ $varc
    set varslope_ $vars
    set fid_ $fid
}

Agent/RigidRcvr instproc init {delc dels varc vars fid} {
    $self next 
    $self instvar util delconst_ delslope_ varconst_ varslope_ fid_

    set util [new Utility]
    set delconst_ $delc 
    set delslope_ $dels
    set varconst_ $varc
    set varslope_ $vars
    set fid_ $fid
}

Agent/RigidRcvr2 instproc init {delc dels varc vars fid} {
    $self next 
    $self instvar util delconst_ delslope_ varconst_ varslope_ fid_

    set util [new Utility]
    set delconst_ $delc 
    set delslope_ $dels
    set varconst_ $varc
    set varslope_ $vars
    set fid_ $fid
}

Agent/NullRcvr instproc init {delc dels varc vars fid} {
    $self next 
    $self instvar util delconst_ delslope_ varconst_ varslope_ fid_

    set util [new Utility]
    set delconst_ $delc 
    set delslope_ $dels
    set varconst_ $varc
    set varslope_ $vars
    set fid_ $fid
}

Agent instproc print_stats {} {
    global total out
    $self instvar util ndelay_ npkts_ nvar_ delconst_ delslope_ varconst_ varslope_ fid_
    $self get_avgdel
    $self get_avgdis
#    set delutil [$util adpt-rcvr $delconst_ $delslope_ [expr $ndelay_ * 1.0/($npkts_*8)]]
#    set varutil [$util adpt-rcvr $varconst_ $varslope_ [expr sqrt($nvar_*1.0/$npkts_)*20.0]]
#    puts "Delay : [expr  $ndelay_  * 1.0/($npkts_*8000) ] Delutil: $delutil"
#    puts "Variance : [expr sqrt([$self set nvar_]/[$self set npkts_])] varutil: $varutil"
#    puts "DELVAR product : [expr $delutil * $varutil]"
#    puts stderr "$fid_ $total [expr  $ndelay_  * 1.0/($npkts_*8) ] [expr sqrt($nvar_*1.0/$npkts_)*20.0] $delutil $varutil [expr $delutil * $varutil]"
#    puts $out "$fid_ $total [expr  $ndelay_  * 1.0/($npkts_*8) ] [expr sqrt($nvar_*1.0/$npkts_)*20.0] "
    puts stderr "$fid_ $total [expr $ndelay_/8.0] [expr $nvar_*20.0]"
#    flush $out
}

Agent/ConsRcvr instproc init {delc dels varc vars fid} {
    $self next 
    $self instvar util delconst_ delslope_ varconst_ varslope_ fid_

    set util [new Utility]
    set delconst_ $delc 
    set delslope_ $dels
    set varconst_ $varc
    set varslope_ $vars
    set fid_ $fid
}


Simulator instproc create-receiver {node rcvrType fid delType disType} {
    global uval
    set mdel $uval(m-$delType)
    set cdel $uval(c-$delType)
    set mdis $uval(m-$disType)
    set cdis $uval(c-$disType)
    set v [new Agent/$rcvrType $cdel $mdel $cdis $mdis $fid]
    $self attach-agent $node $v
    return $v
}

Simulator instproc create-sender {node rate rcvr fid sndType } {
    global runtime btime itime
    set s [new Agent/CBR/UDP]
    $self attach-agent $node $s
    #Create exp on/off source
    if { $sndType == "expo" } {
	set tr [new Traffic/Expoo]
	$tr set packet-size 200
	$tr set burst-time $btime
	$tr set idle-time $itime
	$tr set rate $rate
    } else {    
	#create victrace source
	set tfile [new Tracefile]
	$tfile filename vic.32.200
	set tr [new Traffic/Trace]
	$tr attach-tracefile $tfile

    }

    $s attach-traffic $tr
    $s set fid_ $fid
    
    $self connect $s $rcvr
    $self at [expr double([ns-random] % 10000000) / 1e7 * 60]  "$s start"
    $self at $runtime "$s stop"
}
    
 
#source tcl/qos/util.tcl

set ns [new Simulator]

set n1 [$ns node]
set n2 [$ns node]


$ns duplex-link $n1 $n2 $bw $delay $qType


set v0 [$ns create-receiver $n2 $rcvr1Type 0 delsens dissens]
set v1 [$ns create-receiver $n2 $rcvr2Type 1 delsens disinses]

set v2 [new Agent/Null]
$ns attach-agent $n2 $v2

set i 0
while { $i < $sources1 } {
    $ns create-sender $n1 $rate $v2 0 $bgsrcType
    incr i
}

set i 0
while { $i < $sources2 } {
    $ns create-sender $n1 $rate $v2 1 $bgsrcType
    incr i
}

#set btime 500ms
#set itime 500ms
$ns create-sender $n1 $rate $v0 0 expo
$ns create-sender $n1 $rate $v1 1 expo


$ns at [expr $runtime+20] "$v0 print_stats;$v1 print_stats;exit 0"
$ns run

